# Remote Qorus Commands
Only for Qorus 5.0 and higher, for Qorus 4.1 see: [4.1](4.1)
Only for Python 3

The `qorus-remote-commands.py` client allow the user to run Qorus and Qore commands on a remote Qorus server using the Qorus HTTP server and receive the output of the executed command in real time.

This allows the Qorus client to be used on any system with python 3 and to access Qorus running in a container or in any other type
of deployment as long as the HTTP server is accessible.

## Installation
### Installing pip
In order to install the necessary modules for the client, you will need to have `pip` installed.
pip is already installed if you are using Python 2 >=2.7.9 or Python 3 >=3.4

To install pip, use curl:

`curl https://bootstrap.pypa.io/get-pip.py -o get-pip.py`

Then run the following command in the folder where you have downloaded get-pip.py:

`python get-pip.py`

### Installing modules
`pip install asyncio`
`pip install requests`
`pip install urllib3`
`pip install websocket-client`
`pip install yaml`

## Usage
`./qorus-remote-commands.py [-h|--help|--usage] <NETRC-FILE> <COMMAND> [<COMMAND-ARGS> ...]`

## .netrc file
| Variable | Description | Mandatory |
| --- | --- | --- |
| `machine` | ip adress of the Qorus server machine | Yes |
| `port` | port of the Qorus server machine | Yes |
| `secure` | `yes` if the Qorus server is on `https`, no otherwise | Yes |
| `login` | Qorus username | Yes |
| `password` | Qorus password | Yes |
| `timeout` | Maximum time in seconds allowed for each of the curl operation | No |
| `verbose` | Makes the script verbose | No |
| `nodelete` | Does not delete the upload folder on the server | No |

### example .netrc file
For a Qorus server located on https://localhost:8011 and using the adm Qorus user:
```
machine localhost
port 8011
secure yes
login adm
password adm
timeout 120
verbose no
```

## qorus commands
`oload`\
`ocmd`\
`ojview`\
`oprop`\
`ostart`\
`ostatus`\
`ostop`\
`oview`\
`make-release`\
`qctl`\
`qrest`\
`schema-tool`\
`user-tool`

## qore commands
`rest`\
`schema-reverse`\
`sfrest`\
`soaputil`\
`sqlutil`\
`qdp`\
`saprest`