# Remote Qorus Commands
Only for Qorus 5.0 and higher, for Qorus 4.1 see: [4.1](4.1)

The `qorus-remote-commands.sh` script implements Bourne shell function that allow the user
to run Qorus and Qore commands on a remote Qorus server using the Qorus HTTP server.

Source the script with `. qorus-remote-commands.sh` and then you can use the functions
directly or create aliases to use the shell functions as drop-in replacements for Qorus and
Qore command-line programs.

This allows the Qorus client to be used on any system with a Bourne shell (UNIX / Linux or
even Windows with WSL/WSL2) and to access Qorus running in a container or in any other type
of deployment as long as the HTTP server is accessible.

## Usage
`remote-<COMMAND-NAME> <NETRC-FILE> [<COMMAND-ARGS> ...]`

## .netrc file
| Variable | Description | Mandatory |
| --- | --- | --- |
| `machine` | ip adress of the Qorus server machine | Yes |
| `port` | port of the Qorus server machine | Yes |
| `secure` | `yes` if the Qorus server is on `https`, no otherwise | Yes |
| `login` | Qorus username | Yes |
| `password` | Qorus password | Yes |
| `timeout` | Maximum time in seconds allowed for each of the curl operation | No |
| `verbose` | Makes the script verbose | No |
| `nodelete` | Does not delete the upload folder on the server | No |

### example .netrc file
For a Qorus server located on https://localhost:8011 and using the adm Qorus user:
```
machine localhost
port 8011
secure yes
login adm
password adm
timeout 120
verbose no
```

## qorus commands
`remote-oload`\
`remote-ocmd`\
`remote-ojview`\
`remote-oprop`\
`remote-ostart`\
`remote-ostatus`\
`remote-ostop`\
`remote-oview`\
`remote-make-release`\
`remote-qctl`\
`remote-qrest`\
`remote-schema-tool`\
`remote-user-tool`

## qore commands
`remote-rest`\
`remote-schema-reverse`\
`remote-sfrest`\
`remote-soaputil`\
`remote-sqlutil`\
`remote-qdp`\
`remote-saprest`

## Aliases
In order to use the qorus-remote-commands script in a seamless way, you can create aliases as follows
(substitute the name of the netrc file for each specific environment as needed):
```
alias oload='remote-oload ~/.netrc-xxxx'
alias make-release='remote-make-release ~/.netrc-xxxx'
alias ocmd='remote-ocmd ~/.netrc-xxxx'
alias ojview='remote-ojview ~/.netrc-xxxx'
alias oprop='remote-oprop ~/.netrc-xxxx'
alias ostart='remote-ostart ~/.netrc-xxxx'
alias ostatus='remote-ostatus ~/.netrc-xxxx'
alias ostop='remote-ostop ~/.netrc-xxxx'
alias oview='remote-oview ~/.netrc-xxxx'
alias qctl='remote-qctl ~/.netrc-xxxx'
alias qrest='remote-qrest ~/.netrc-xxxx'
alias schema-tool='remote-schema-tool ~/.netrc-xxxx'
alias user-tool='remote-user-tool ~/.netrc-xxxx'
alias rest='remote-rest ~/.netrc-xxxx'
alias schema-reverse='remote-schema-reverse ~/.netrc-xxxx'
alias sfrest='remote-sfrest ~/.netrc-xxxx'
alias soaputil='remote-soaputil ~/.netrc-xxxx'
alias sqlutil='remote-sqlutil ~/.netrc-xxxx'
alias qdp='remote-qdp ~/.netrc-xxxx'
alias saprest='remote-saprest ~/.netrc-xxxx'
```
